package ADS;

import javax.swing.*;
/**
 * berschrift:   Klassen zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */

public class HashCoal extends Hashing implements SuchStruk{

  public HashCoal() {  super();
    for (int i=0; i<maxAnz; i++) Speicher[i]=new CoalItem();
  }

  public HashCoal(int dimension) {  super(dimension);
    for (int i=0; i<maxAnz; i++) Speicher[i]=new CoalItem();
  }

  public int suchPos(String s) {
    boolean ok,Abbr; CoalItem CI;
    int i=Hashfkt(s);
    do {
      CI=(CoalItem) getElement(i);
      ok=CI.Inhalt!=null && s.equals(CI.getSchluessel());
      Abbr=(CI.nxt==-1);
      if (!(ok || Abbr)) i=CI.nxt;
    } while (!(ok || Abbr));
    if (ok) return i; else return -1;
  }

  public Elementtyp suchen(String s) {
    int SuchPos=suchPos(s);
    if (SuchPos>=0)
      return (((CoalItem) getElement(SuchPos)).Inhalt);
    else return null;
  }

  public boolean einfuegen(Elementtyp e) {
    int i,j; boolean ok,Abbr=false; CoalItem CI;
    if (istVoll()) return false;
    else {
      String s=e.getSchluessel();
      if (suchPos(s)>=0) return false;
      else {
        j=Hashfkt(s);
        do {
          CI=(CoalItem) getElement(j);
          Abbr=CI.Inhalt==null || CI.nxt==-1;
          if (!Abbr) j=CI.nxt;
        } while (!Abbr);
        if (CI.Inhalt==null) CI.Inhalt=e;
        else {
          i=maxAnz-1;
          while (i>0 && ((CoalItem) getElement(i)).Inhalt!=null) i--;
          CI.nxt=i;
          CI=(CoalItem) getElement(i);
          CI.Inhalt=e;
        }
        Anz++; return true;
      }
    }
  }

  public boolean entfernen(String s) {
    boolean ok,Abbr; CoalItem CI;
    if (istLeer()) return false;
    else {
      int j=Hashfkt(s);
      do {
        CI=(CoalItem) getElement(j);
        ok=CI.Inhalt!=null && CI.Inhalt.getSchluessel().equals(s);
        Abbr=CI.nxt==-1;
        if (!(ok || Abbr)) j=CI.nxt;
      } while(!(ok || Abbr));
      if (ok) { CI.Inhalt=null; Anz--; }
      return ok;
    }
  }

  public void Ausg(JTable T) {
    String S=new String();
    for (int i=0; i<maxAnz; i++) {
      CoalItem CI=(CoalItem) getElement(i);
      T.setValueAt(CI.getSchluessel(),0,i);
      T.setValueAt(S.valueOf(CI.nxt),1,i);
    }
  }

  class CoalItem extends HashItem {
    protected int nxt;

    public CoalItem() { super(); nxt=-1; }

    public CoalItem(Elementtyp e) { super(e); nxt=-1; }
  }

}