package ADS;

import javax.swing.*;

/**
 * berschrift:   Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */

public class HashKett extends Hashing implements SuchStruk{

  public HashKett() {
    super();
    for (int i=0; i<n; i++) setElement(new KettItem(),i);
  }

  public HashKett(int dimension) {
    super(dimension);
    for (int i=0; i<n; i++) setElement(new KettItem(),i);
  }

  public boolean istVoll() { return false; }

  KettItem suchPos(String s) {
    KettItem z=(KettItem) getElement(Hashfkt(s));
    boolean ok=false;  boolean Abbr=z.Inhalt==null;
    while (!(ok || Abbr)) {
      ok=s.equals(z.Inhalt.getSchluessel());
      Abbr=z.nxt==null;
      if (!(ok || Abbr)) z=z.nxt;
    }
    return z;
  }

  public Elementtyp suchen(String s) {
    KettItem h=suchPos(s);
    return h.Inhalt;
  }

  public boolean einfuegen(Elementtyp e) {
    Elementtyp d=suchen(e.getSchluessel());
    if(d!=null && d.getSchluessel().equals(e.getSchluessel()))
      return false;
    else{
      Anz++;
      int pos=Hashfkt(e.getSchluessel());
      KettItem z=(KettItem)getElement(pos);
      if(z.Inhalt==null)
        z.Inhalt=e;
      else{
        while(z.nxt!=null)
          z=z.nxt;
        z.nxt=new KettItem(e);
      }
      return true;
    }
  }

  public boolean entfernen(String s) {
    KettItem KI=suchPos(s);
    if (KI.getSchluessel().equals(s)) { Anz--;
      int i=Hashfkt(s);
      KettItem z=(KettItem) getElement(i);
      if (z==KI)
        if (z.nxt!=null) setElement(z.nxt,i);
        else z.Inhalt=null;
      else { KettItem vor=z; z=z.nxt;
        while (z!=KI) { vor=z; z=z.nxt; }
        vor.nxt=z.nxt;
      }
      return true;
    }
    else return false;
  }

  public String Ausgabe(int i) {
    KettItem KI=(KettItem) getElement(i);
    String result=String.valueOf(i)+": "+KI.getSchluessel();
    KI=KI.nxt;
    while (KI!=null) {
      result=result+" -> "+KI.getSchluessel();
      KI=KI.nxt;
    }
    return result;
  }

  class KettItem extends HashItem {
    protected KettItem nxt;

    public KettItem() { Inhalt=null; nxt=null; }

    public KettItem(Elementtyp e) { Inhalt=e; nxt=null; }
  }
}