package ADS;

public abstract class Heap
{/** Basisklasse fr Klassen mit einem Array als Speicher: Priorheap, Schlange,
   * AListe, Hashing, Segmentbaum, ...
   */
  protected Object [] Speicher;
  protected int maxAnz; //Kapazitt des Speichers
  protected int n=0;    //aktuelle Elementanzahl

  public Heap() { }

  public Heap(int maxAnz) {
  // - erzeugt einen leeren Heap fr maximal maxAnz Objekte
    this.maxAnz=maxAnz;
    n=0;
    Speicher = new Object[maxAnz];
  }

  public int count() { return n; }
  // - liefert die Anzahl der aktuell im Heap befindlichen Objekte

  public boolean istPos(int i) { return (0<=i) && (i<n);}
  // - liefert true, wenn i gltige Heapposition ist

  public boolean istLeer() { return (n==0);}
  // - liefert true, wenn der Heap leer ist

  public boolean istVoll() { return (n==maxAnz); }
  // - liefert true, wenn der Heap maxAnz Objekte enthlt

  public int first() {  return 0;  }
  // - liefert die erste gltige Heapposition (0)

  public int last() {   return n-1; }
  // - liefert die letzte gltige Heapposition (count-1)

  public int prev(int i)
  // - liefert die  vor i liegende Heapposition (i-1)
  {
    if (istPos(i)) return i-1;  else return last();
  }

  public int next(int i)
  // - liefert die  auf i folgende Heapposition (i+1)
  {
    if (istPos(i)) return i+1;  else return first();
  }

  public int nachb(int k, int i)
  // - liefert  (i+k)
  { return i+k; }

  public Object getElement(int i)
  // - liefert das i-te Objekt im Heap
  {
    if (istPos(i)) return Speicher[i]; else return null;
  }

  public void setElement(Object e, int i)
  // - schreibt e auf die i-te Position im Heap
  { if (istPos(i)) Speicher[i]=e; }

  public void elemTausch(int i, int j)
  // - vertauscht im Heap die Inhalte der Position i und j
  { if (istPos(i) && istPos(j)) {
      Object e=Speicher[i];
      Speicher[i]=Speicher[j];
      Speicher[j]=e;
    }
  }

}
