package ADS;

/**
 * berschrift:   Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */

public class Segmentbaum extends Heap {
  protected int breite;

  public Segmentbaum(int breite) {
    int[] hInt=Elementtyp.mod2Hoch(breite);
    if (hInt[0]>0) this.breite=2*hInt[2]; else this.breite=breite;
    maxAnz=2*this.breite-1;
    n=maxAnz;
    Speicher = new Object[maxAnz];
    for (int i=0; i<maxAnz; i++) setElement(new AVLBaum(),i);
  }

  public LIntervall knInt(int i) {
    if (i==0) return new LIntervall(0,breite);
    else {
      int[] hInt=Elementtyp.mod2Hoch(i+1);
      int pot=breite>>>hInt[1];
      int li=hInt[0]*pot;  int re=(hInt[0]+1)*pot;
      return new LIntervall(li,re);
    }
  }

  private boolean einfueg(LIntervall iv, int i) {
  //=true, wenn mindestens einmal eingefgt
    boolean ok=false;
    if (knInt(i).istIn(iv)) {
      ok=((AVLBaum) getElement(i)).einfuegen(iv);
    }
    else {
      int j=2*i+1;
      if (istPos(j) && knInt(j).hatSchnitt(iv)) ok=einfueg(iv,j);
      j++;
      if (istPos(j) && knInt(j).hatSchnitt(iv)) ok=(einfueg(iv,j) || ok);
    }
    return ok;
  }

  public boolean einfuegen(LIntervall iv) {
    if (iv.istIn(knInt(0))) return einfueg(iv,0);
    else return false;
  }

  private boolean entfern(LIntervall iv, int i) {
    //analog zu einfueg()
    boolean ok=false;
    if(knInt(i).istIn(iv))
      ok=((AVLBaum) getElement(i)).entfernen(iv.getSchluessel());
    else {
      int j=2*i+1;
      if(istPos(j) && knInt(j).hatSchnitt(iv)) ok=entfern(iv,j);
      if(istPos(j+1) && knInt(j+1).hatSchnitt(iv)) ok=(entfern(iv,j+1)||ok);
    }
    return ok;
  }

  public boolean entfernen(LIntervall iv) {
    if (iv.istIn(knInt(0))) return entfern(iv,0);
    else return false;
  }

  private void report(int i, int nadel, AVLBaum Schnittmenge) {
  /** i=Knotennummer (Knoten ist AVLBaum, der LIntervalle enthlt);
   *  falls der Knoten i LIntervalle enthlt, werden diese in die Schittmenge
   *  eingefgt; anschlieend wird rekursiv die Methode fr jeden der Shne
   *  aufgerufen, dessen Knotenintervall die Nadel enthlt.
   */
    if(((AVLBaum)getElement(i)).Wurzel!=null){
      AVLKnoten SchlKn=((AVLBaum)getElement(i)).minSchlKn();
      do{
        Schnittmenge.einfuegen(SchlKn.getInhalt());
        SchlKn=((AVLBaum)getElement(i)).nextSchl(SchlKn);
      }while(SchlKn!=null);
    }
    int j=2*i+1;
    if(istPos(j) && knInt(j).enthaelt(nadel)) report(j,nadel,Schnittmenge);
    else if(istPos(j+1)) report(j+1,nadel,Schnittmenge);
  }

  public AVLBaum spiess(int nadel) {
  /** Falls die Wurzel (Knoten 0) die Nadel enthlt, wir zur Ergebnisbergabe
   *  ein AVLBaum erzeugt und die Hilfsprozedur Report fr die Wurzel, die Nadel
   *  und den Ergebnisbaum aufgerufen.
   */
    if (knInt(0).enthaelt(nadel)) {
      AVLBaum result=new AVLBaum();
      report(0,nadel,result);
      return result;
    }
    else return null;
  }

  public int[] mod2Hoch(int z) {
    int [] result=new int[3]; int Z=z;
    result[1]=0;
    if (z>0) {
      while (Z!=1) { Z=Z>>>1; result[1]++; }
      result[2]=1<<result[1];
      result[0]=z-result[2];
    }
    else { result[0]=0; result[1]=0; }
    return result;
  }

}