package ADS;

/**
 * berschrift:   Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */

public class SortArray extends AListe {

  public SortArray(int maxAnz) { super(maxAnz); }

  public void AuswahlSort() {
    int i,j,minPos; String minS;
    i=first();
    while (istPos(i)) {
      minPos=i;
      minS=((Elementtyp) getElement(minPos)).getSchluessel();
      j=next(i);
      while (istPos(j)) {
        if (((Elementtyp) getElement(j)).getSchluessel().compareTo(minS)<0) {
          minPos=j;
          minS=((Elementtyp) getElement(minPos)).getSchluessel();
        }
        j=next(j);
      }
      elemTausch(i,minPos);
      i=next(i);
    }
  }

  public void BubbleSort() {
    int i; boolean found;
    do {
      found=false;
      i=next(first());
      while (istPos(i)) {
        if ((((Elementtyp) getElement(i)).getSchluessel()).
            compareTo(((Elementtyp) getElement(prev(i))).getSchluessel())<0) {
          elemTausch(i,prev(i));
          found=prev(i)!=first();
        }
        i=next(i);
      }
    } while (found);
  }

  public void EinfuegeSort() {
    int i,j; Elementtyp el; String S;
    i=next(first());
    while (istPos(i)) {
      //fuege Element[i] zwischen 0 und i-1 ein:
      el=(Elementtyp) getElement(i);
      S=el.getSchluessel();
      j=prev(i);
      while (istPos(j) &&
             S.compareTo(((Elementtyp) getElement(j)).getSchluessel())<0) {
        setElement(getElement(j),next(j));
        j=prev(j);
      }
      setElement(el,next(j));
      i=next(i);
    }
  }

  public void QuickSort(int li, int re) {
    int teilpkt=Teilpkt(li, re);
    if (teilpkt!=li) QuickSort(li, prev(teilpkt));
    if (teilpkt!=re) QuickSort(next(teilpkt),re);
  }

  public int Teilpkt(int li, int re) {
    String ResultS=new String(); String liS=new String();
    String reS=new String();
    int Result=li;
    boolean fertig=(Result==re);
    if (!fertig) {
      ResultS=((Elementtyp) getElement(Result)).getSchluessel();
      reS=((Elementtyp) getElement(re)).getSchluessel();
      if (reS.compareTo(ResultS)<0) { elemTausch(Result,re); reS=ResultS; }
      if (next(Result)!=re) {
        Result=next(Result);
        ResultS=((Elementtyp) getElement(Result)).getSchluessel();
        if (reS.compareTo(ResultS)<0) {elemTausch(Result,re); ResultS=reS; }
        liS=((Elementtyp) getElement(li)).getSchluessel();
        if (liS.compareTo(ResultS)>0) { elemTausch(Result,li); ResultS=liS; }
        fertig=next(Result)==re;
        if (!fertig) {
          int i=Result; int j=prev(re);
          do {
            while (i!=Result &&
                   ResultS.compareTo(
                              ((Elementtyp) getElement(i)).getSchluessel())>=0)
              i=next(i);
            while (j!=Result &&
                   ResultS.compareTo(
                              ((Elementtyp) getElement(j)).getSchluessel())<=0)
              j=prev(j);
            if (i!=j) {
              elemTausch(i,j);
              if (i==Result) Result=j;
              else if (j==Result) Result=i;
            }
          } while (i!=j);
        }
      }
    }
    return Result;
  }

  public void MergeSort() {
    Schlange HL=new Schlange(count());
    int i,iE,j,jE,tlLg; boolean Abbr;
    tlLg=1;
    while (tlLg<count()) {
      jE=prev(first());
      do {
        i=next(jE); iE=nachb(i,tlLg-1);
        if (istPos(iE) && iE!=last()) {
          j=next(iE); jE=nachb(j,tlLg-1); if (!istPos(jE)) jE=last();
          do {
            if ((((Elementtyp) getElement(i)).getSchluessel()).compareTo(
                 ((Elementtyp) getElement(j)).getSchluessel())<=0) {
              HL.push(getElement(i));
              Abbr=i==iE;
              if (!Abbr) i=next(i);
              else {
                while (j!=jE) { HL.push(getElement(j)); j=next(j); }
                HL.push(getElement(jE));
              }
            }
            else {
              HL.push(getElement(j));
              Abbr=j==jE;
              if (!Abbr) j=next(j);
              else {
                while (i!=iE) { HL.push(getElement(i)); i=next(i); }
                HL.push(getElement(iE));
              }
            }
          } while (!Abbr);
        }
        else jE=last();
      } while (jE!=last());
      i=first();
      while (!HL.istLeer()) { setElement(HL.exTop(),i); i=next(i); }
      tlLg=2*tlLg;
    }
  }

  public void RadixSort() {
    int a,h,i,k,r;
    AListe HL=new AListe(count());
    for (i=0; i<count(); i++) HL.add(null);
    int [] z=new int[Elementtyp.Radix];
    for (k=Elementtyp.AnzSchlSt-1; k>=0; k--) {
      for (r=0; r<Elementtyp.Radix; r++) z[r]=0;
      i=first();
      while (istPos(i)) {
        z[Elementtyp.ZWert(((Elementtyp) getElement(i)).getSchluessel(),k)]++;
        i=next(i);
      }
      a=0;
      for (r=0; r<Elementtyp.Radix; r++) {
        h=z[r]; z[r]=a; a=a+h;
      }
      i=first();
      while (istPos(i)) {
        r=Elementtyp.ZWert(((Elementtyp) getElement(i)).getSchluessel(),k);
        HL.setElement(getElement(i),z[r]);
        z[r]++;
        i=next(i);
      }
      i=first();
      for (r=0; r<count(); r++) {
        setElement(HL.getElement(r),i);
        i=next(i);
      }
    }
  }

  public void BitSort(int li, int re, int AnzBitSt) {
    int i,j,k;
    k=AnzBitSt-1;
    if (li!=re) {
      i=li; j=re;
      do {
        while (i!=re && !((ElementtypI) getElement(i)).BitWert(k)) i=next(i);
        while (j!=li &&  ((ElementtypI) getElement(j)).BitWert(k)) j=prev(j);
        if ( !(i==j || j==prev(i))) elemTausch(i,j);
      } while (!(i==j || j==prev(i)));
      if (AnzBitSt>1) {
        BitSort(li,j,AnzBitSt-1);
        BitSort(i,re,AnzBitSt-1);
      }
    }
  }

  public void PrllMergeSrt() {
    int Teillistenlg=1;
    Elementtyp[] HL=new Elementtyp[n];
    while (Teillistenlg<n) {
      for (int i=0; i<n; i++) /** with Prozessor i do */
        HL[Position(i,Teillistenlg)]=(Elementtyp) getElement(i);
      for (int i=0; i<n; i++) /** with Prozessor i do */ setElement(HL[i],i);
      Teillistenlg=2*Teillistenlg;
    }
  }

  private int Position(int i, int Teillistenlg) {
    int iTL, ATLi, ATLj, j, jA, jE, Result;
    String iS=((Elementtyp) getElement(i)).getSchluessel(), jS;
    ATLi=(i/Teillistenlg)*Teillistenlg;
    if (((ATLi/Teillistenlg) % 2)==1) { ATLj=ATLi-Teillistenlg; Result=ATLj; }
    else { ATLj=ATLi+Teillistenlg; Result=ATLi; }
    if (ATLj>n-1) Result=i;
    else /** Binrsuche */ {
      jA=ATLj; jE=jA+Teillistenlg-1; if (jE>n-1) jE=n-1;
      j=jA;
      while (jA<=jE) {
 	j=(jA+jE)/2;
        jS=((Elementtyp) getElement(j)).getSchluessel();
        if (iS.compareTo(jS)<=0) jE=j-1; else jA=j+1;
      }
      Result=Result+(i-ATLi)+(jA-ATLj);
    }
    return Result;
  }

  public void EOSort(int iA, int iE) {
    int i,iM; String S1,S2;
    Elementtyp[] F1,F2, F3;
    if (iA<iE)
      if (iA+1==iE) {
        S1=((Elementtyp) getElement(iA)).getSchluessel();
        S2=((Elementtyp) getElement(iE)).getSchluessel();
        if (S1.compareTo(S2)>0) elemTausch(iA,iE);
      }
      else {
        iM=(iA+iE)/2;
        EOSort(iA,iM); EOSort(iM+1,iE);
        F1=new Elementtyp[iM-iA+1]; F2=new Elementtyp[iE-iM];
        for (i=0; i<=iM-iA;   i++) F1[i]=((Elementtyp) getElement(iA+i));
        for (i=0; i<=iE-iM-1; i++) F2[i]=((Elementtyp) getElement(iM+1+i));
        F3=EOMerge(F1,F2);
        for (i=0; i<=iE-iA; i++) setElement(F3[i],iA+i);
      }
  }

  private Elementtyp[] EOMerge(Elementtyp[] f1, Elementtyp[] f2) {
    int i0,i,N1=f1.length,N2=f2.length; String S1,S2;
    Elementtyp[] F1,F2,F3,F4,Result=new Elementtyp[N1+N2];
    if (N1>1 || N2>1) {
      F1=new Elementtyp[N1-N1/2];
      F2=new Elementtyp[N2-N2/2];
      F3=new Elementtyp[N1/2];
      F4=new Elementtyp[N2/2];
      for (i=0; i<N1-N1/2; i++) { F1[i]=f1[2*i]; if (2*i+1<N1) F3[i]=f1[2*i+1]; }
      for (i=0; i<N2-N2/2; i++) { F2[i]=f2[2*i]; if (2*i+1<N2) F4[i]=f2[2*i+1]; }
      f1=EOMerge(F1,F2);
      if (F3.length>0 && F4.length>0) f2=EOMerge(F3,F4);
      else {
        for (i=0; i<F3.length; i++) f2[i]=F3[i];
        i0=F3.length;
        for (i=0; i<F4.length; i++) f2[i0+i]=F4[i];
      }
      N1=f1.length; N2=f2.length;
      Result[0]=f1[0];
      i=1;
      while (i<N1 && i<=N2) {
        S1=f1[i].getSchluessel(); S2=f2[i-1].getSchluessel();
        if (S1.compareTo(S2)<0) { Result[2*i-1]=f1[i]; Result[2*i]=f2[i-1]; }
        else { Result[2*i-1]=f2[i-1]; Result[2*i]=f1[i]; }
        i++;
      }
      if (i<N1 || i<=N2)
        if (i<=N2) Result[N1+N2-1]=f2[N2-1]; else Result[N1+N2-1]=f1[N1-1];
    }
    else {
      S1=f1[0].getSchluessel(); S2=f2[0].getSchluessel();
      if (S1.compareTo(S2)<0) { Result[0]=f1[0]; Result[1]=f2[0]; }
        else { Result[0]=f2[0]; Result[1]=f1[0]; }
    }
    return Result;
  }

}